## ----setup, include=FALSE------------------------------------------------
#setwd("/Users/Xavi/Dropbox/xavi-umh/docencia/")
#setwd("~/Dropbox/xavi-umh/docencia/TEIM/2016-2017/temas/tema1")
setwd("~/Dropbox/xavi-umh/docencia/SERIES/2018/TEMA 02")

 library(knitr)
 library(rmarkdown)
 library(xtable)
 library(highlight)
library(stargazer)
library(texreg)
library(caret)
options(xtable.comment = FALSE)
knitr::opts_chunk$set(width.cutoff=100, fig.width=3, fig.height=2.8, size="normalsize", warning=FALSE, message=FALSE, echo=FALSE, tidy=TRUE, width=60)
knitr::opts_chunk$set(tidy.opts=list(width.cutoff=60))
opts_knit$set(root.dir = "~/Dropbox/xavi-umh/docencia/SERIES/2018/TEMA 02")

## ---- tidy=F, results='hide'---------------------------------------------
library(astsa)
pdf("img/serie4.pdf")
plot(gtemp, xlab="Year", ylab="Deviation")
dev.off()

## ---- echo=TRUE, eval=F--------------------------------------------------
## gas = scan('http://verso.mat.uam.es/~joser.berrendero/datos/gas6677.dat')
## plot(gas)

## ---- echo=F, results='hide'---------------------------------------------
gas = scan('http://verso.mat.uam.es/~joser.berrendero/datos/gas6677.dat')
pdf("img/serie7.pdf")
plot(gas)
dev.off()

## ---- echo=TRUE----------------------------------------------------------
gas.ts = ts(gas, start = c(1966,1), frequency = 12)

## ------------------------------------------------------------------------
print(gas.ts)

## ---- ercho=T, eval=FALSE------------------------------------------------
## plot(gas.ts)

## ---- ercho=FALSE, results='hide'----------------------------------------
pdf("img/serie9.pdf")
plot(gas.ts)
dev.off()

## ---- echo=TRUE, eval=FALSE----------------------------------------------
## boxplot(gas.ts ~ cycle(gas.ts))

## ---- echo=FALSE, results='hide'-----------------------------------------
pdf("img/serie8.pdf")
boxplot(gas.ts ~ cycle(gas.ts))
dev.off()

## ---- tidy=F, results='hide'---------------------------------------------
library(astsa)
pdf("img/serie5.pdf")
plot(diff(gtemp), xlab="Year", ylab="Deviation")
dev.off()

## ---- results='hide'-----------------------------------------------------
pdf("img/serie6.pdf")
set.seed(123456)
e<-rnorm(500)
#purerandomwalk3
rw.nd<-cumsum(e)
#trend5
trd<-1:500
#randomwalkwithdrift7
rw.wd<-0.5*trd+cumsum(e)
#deterministictrendandnoise9
dt<-e+0.5*trd
#plotting11
par(mar=rep(5,4))
plot.ts(dt,lty=1,ylab='',xlab='')
lines(rw.wd,lty=2)
par(new=T)
plot.ts(rw.nd,lty=3,axes=FALSE)
axis(4,pretty(range(rw.nd)))
lines(rw.nd,lty=3)
legend(10,18.7,legend=c('det.trend+noise(ls)','rwdrift(ls)','rw(rs)'),lty=c(1,2,3))
dev.off()

## ---- results='hide'-----------------------------------------------------
library(fpp)
data(ausbeer)
timeserie_beer = tail(head(ausbeer, 17*4+2),17*4-4)
pdf("img/serie11.pdf")
plot(as.ts(timeserie_beer))
dev.off()

## ---- results='hide'-----------------------------------------------------
library(Ecdat)
data(AirPassengers)
timeserie_air = AirPassengers
pdf("img/serie12.pdf")
plot(as.ts(timeserie_air))
dev.off()

## ---- results='hide'-----------------------------------------------------
library(forecast)
trend_beer = ma(timeserie_beer, order = 4, centre = T)
pdf("img/serie13.pdf")
plot(as.ts(timeserie_beer))
lines(trend_beer)
plot(as.ts(trend_beer))
dev.off()

## ---- results='hide'-----------------------------------------------------
trend_air = ma(timeserie_air, order = 12, centre = T)
pdf("img/serie14.pdf")
plot(as.ts(timeserie_air))
lines(trend_air)
plot(as.ts(trend_air))
dev.off()

## ---- echo=T, eval=FALSE-------------------------------------------------
## plot(as.ts(timeserie_beer))

## ---- echo=T, eval=F-----------------------------------------------------
## head(ausbeer,16)

## ---- echo=F, eval=T-----------------------------------------------------
kable(xtable(head(ausbeer,16)))

## ---- echo=TRUE, eval=FALSE----------------------------------------------
## library(forecast)
## trend_beer = ma(timeserie_beer, order = 4, centre = T)
## plot(as.ts(timeserie_beer))
## lines(trend_beer)
## plot(as.ts(trend_beer))

## ---- echo=F, eval=T, results='hide'-------------------------------------
library(forecast)
trend_beer = ma(timeserie_beer, order = 4, centre = T)
pdf("img/serie19.pdf")
plot(as.ts(timeserie_beer))
lines(trend_beer)
plot(as.ts(trend_beer))
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## detrend_beer = timeserie_beer - trend_beer
## plot(as.ts(detrend_beer))

## ----echo=F, eval=T, results='hide'--------------------------------------
detrend_beer = timeserie_beer - trend_beer
pdf("img/serie20.pdf")
plot(as.ts(detrend_beer))
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## m_beer = t(matrix(data = detrend_beer, nrow = 4))
## seasonal_beer = colMeans(m_beer, na.rm = T)
## plot(as.ts(rep(seasonal_beer,16)))

## ----echo=F, eval=T, results='hide'--------------------------------------
m_beer = t(matrix(data = detrend_beer, nrow = 4))
seasonal_beer = colMeans(m_beer, na.rm = T)
pdf("img/serie21.pdf")
plot(as.ts(rep(seasonal_beer,16)))
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## random_beer = timeserie_beer - trend_beer - seasonal_beer
## plot(as.ts(random_beer))

## ----echo=F, eval=T, results='hide'--------------------------------------
random_beer = timeserie_beer - trend_beer - seasonal_beer
pdf("img/serie22.pdf")
plot(as.ts(random_beer))
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## ts_beer = ts(timeserie_beer, frequency = 4)
## decompose_beer = decompose(ts_beer, "additive")
## 
## plot(as.ts(decompose_beer$seasonal))
## plot(as.ts(decompose_beer$trend))
## plot(as.ts(decompose_beer$random))
## plot(decompose_beer)

## ----echo=F, eval=T, results='hide'--------------------------------------
ts_beer = ts(timeserie_beer, frequency = 4)
decompose_beer = decompose(ts_beer, "additive")
pdf("img/serie23.pdf")
par(mfrow=c(2,2))
plot(as.ts(decompose_beer$seasonal))
plot(as.ts(decompose_beer$trend))
plot(as.ts(decompose_beer$random))
dev.off()
pdf("img/serie23b.pdf")
plot(decompose_beer)
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## ts_beer = ts(timeserie_beer, frequency = 4)
## stl_beer = stl(ts_beer, "periodic")
## seasonal_stl_beer   <- stl_beer$time.series[,1]
## trend_stl_beer     <- stl_beer$time.series[,2]
## random_stl_beer  <- stl_beer$time.series[,3]
## 
## plot(ts_beer)
## plot(as.ts(seasonal_stl_beer))
## plot(trend_stl_beer)
## plot(random_stl_beer)
## plot(stl_beer)

## ----echo=F, eval=T, results='hide'--------------------------------------
ts_beer = ts(timeserie_beer, frequency = 4)
stl_beer = stl(ts_beer, "periodic")
seasonal_stl_beer   <- stl_beer$time.series[,1]
trend_stl_beer     <- stl_beer$time.series[,2]
random_stl_beer  <- stl_beer$time.series[,3]
pdf("img/serie24.pdf")
par(mfrow=c(3,2))
plot(ts_beer)
plot(as.ts(seasonal_stl_beer))
plot(trend_stl_beer)
plot(random_stl_beer)
dev.off()
pdf("img/serie24b.pdf")
plot(stl_beer)
dev.off()

## ----echo=T, eval=F, results='hide'--------------------------------------
## rain <- scan("http://robjhyndman.com/tsdldata/hurst/precip1.dat",skip=1)
## rainseries <- ts(rain,start=c(1813))
## plot.ts(rainseries)

## ----echo=F, eval=T, results='hide'--------------------------------------
rain <- scan("http://robjhyndman.com/tsdldata/hurst/precip1.dat",skip=1)
rainseries <- ts(rain,start=c(1813))

## ---- echo=T-------------------------------------------------------------
rainseriesforecasts <- HoltWinters(rainseries, beta=FALSE, gamma=FALSE)
rainseriesforecasts

## ---- echo=TRUE, eval=F--------------------------------------------------
## rainseriesforecasts$fitted

## ---- echo=F-------------------------------------------------------------
kable(xtable(rainseriesforecasts$fitted))

## ---- eval=F, echo=TRUE, results='hide'----------------------------------
## plot(rainseriesforecasts)

## ---- eval=T, echo=F, results='hide'-------------------------------------
pdf("img/serie27.pdf")
plot(rainseriesforecasts)
dev.off()

## ---- echo=T-------------------------------------------------------------
rainseriesforecasts$SSE

## ---- echo=T-------------------------------------------------------------
HoltWinters(rainseries, beta=FALSE, gamma=FALSE, l.start=23.56)

## ---- echo=T-------------------------------------------------------------
library("forecast")
rainseriesforecasts2 <- forecast(rainseriesforecasts, h=8)

## ---- echo=F-------------------------------------------------------------
kable(rainseriesforecasts2)

## ---- eval=F-------------------------------------------------------------
## plot(rainseriesforecasts2)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie28.pdf")
plot(rainseriesforecasts2)
dev.off()

## ---- echo=T, eval=F-----------------------------------------------------
## plot(rainseriesforecasts2$residuals)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie29.pdf")
plot(rainseriesforecasts2$residuals)
dev.off()

## ---- echo=T-------------------------------------------------------------
plotForecastErrors <- function(forecasterrors)
  {
     # make a histogram of the forecast errors:
     mybinsize <- IQR(forecasterrors, na.rm=T)/4
     mysd   <- sd(forecasterrors, na.rm=T)
     mymin  <- min(forecasterrors, na.rm=T) - mysd*5
     mymax  <- max(forecasterrors, na.rm=T) + mysd*3
     # generate normally distributed data with mean 0 and standard deviation mysd
     mynorm <- rnorm(10000, mean=0, sd=mysd)
     mymin2 <- min(mynorm, na.rm=T)
     mymax2 <- max(mynorm, na.rm=T)
     if (mymin2 < mymin) { mymin <- mymin2 }
     if (mymax2 > mymax) { mymax <- mymax2 }
     # make a red histogram of the forecast errors, with the normally distributed data overlaid:
     mybins <- seq(mymin, mymax, mybinsize)
     hist(forecasterrors, col="red", freq=FALSE, breaks=mybins)
     # freq=FALSE ensures the area under the histogram = 1
     # generate normally distributed data with mean 0 and standard deviation mysd
     myhist <- hist(mynorm, plot=FALSE, breaks=mybins)
     # plot the normal curve as a blue line on top of the histogram of forecast errors:
     points(myhist$mids, myhist$density, type="l", col="blue", lwd=2)
  }

## ---- echo=T, eval=F, results='hide'-------------------------------------
## plotForecastErrors(rainseriesforecasts2$residuals)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie30.pdf")
plotForecastErrors(rainseriesforecasts2$residuals)
dev.off()

## ---- echo=T, eval=F, results='hide'-------------------------------------
## skirts <- scan("http://robjhyndman.com/tsdldata/roberts/skirts.dat",skip=5)
##  skirtsseries <- ts(skirts,start=c(1866))
## plot.ts(skirtsseries)

## ---- echo=F, eval=T, results='hide'-------------------------------------
skirts <- scan("http://robjhyndman.com/tsdldata/roberts/skirts.dat",skip=5)
skirtsseries <- ts(skirts,start=c(1866))

## ---- echo=F, eval=T, results='hide'-------------------------------------
kable(xtable(head(skirtsseries)))

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie31.pdf") 
plot.ts(skirtsseries)
dev.off()

## ---- echo=T-------------------------------------------------------------
skirtsseriesforecasts <- HoltWinters(skirtsseries, gamma=FALSE)
skirtsseriesforecasts
skirtsseriesforecasts$SSE

## ---- echo=T, eval=F, results='hide'-------------------------------------
## plot(skirtsseriesforecasts)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie33.pdf") 
plot(skirtsseriesforecasts)
dev.off()

## ---- echo=T-------------------------------------------------------------
HoltWinters(skirtsseries, gamma=FALSE, l.start=608, b.start=9)
skirtsseriesforecasts2 <- forecast(skirtsseriesforecasts, h=19)

## ------------------------------------------------------------------------
kable(skirtsseriesforecasts2)

## ---- echo=T, eval=F, results='hide'-------------------------------------
##  plot(skirtsseriesforecasts2)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie34.pdf") 
 plot(skirtsseriesforecasts2)
dev.off()

## ---- echo=T, eval=F, results='hide'-------------------------------------
## plotForecastErrors(skirtsseriesforecasts2$residuals)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie35.pdf") 
plotForecastErrors(skirtsseriesforecasts2$residuals)
dev.off()

## ---- echo=T, eval=F, results='hide'-------------------------------------
## souvenir <- scan("http://robjhyndman.com/tsdldata/data/fancy.dat")
## souvenirtimeseries <- ts(souvenir, frequency=12, start=c(1987,1))

## ---- echo=F, eval=T-----------------------------------------------------
souvenir <- scan("http://robjhyndman.com/tsdldata/data/fancy.dat") 
souvenirtimeseries <- ts(souvenir, frequency=12, start=c(1987,1))
kable(head(souvenirtimeseries))

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie36.pdf") 
 plot(souvenirtimeseries)
dev.off()

## ---- echo=T, eval=F-----------------------------------------------------
##  logsouvenirtimeseries <- log(souvenirtimeseries)
##  souvenirtimeseriesforecasts <- HoltWinters(logsouvenirtimeseries)
##  souvenirtimeseriesforecasts
## souvenirtimeseriesforecasts$SSE

## ---- echo=F, eval=T-----------------------------------------------------
 logsouvenirtimeseries <- log(souvenirtimeseries)
 souvenirtimeseriesforecasts <- HoltWinters(logsouvenirtimeseries)
 souvenirtimeseriesforecasts
souvenirtimeseriesforecasts$SSE

## ---- eval=F-------------------------------------------------------------
## plot(souvenirtimeseriesforecasts)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie37.pdf")
plot(souvenirtimeseriesforecasts)
dev.off()

## ---- eval=F-------------------------------------------------------------
##  souvenirtimeseriesforecasts2 <- forecast(souvenirtimeseriesforecasts, h=48)
##  plot(souvenirtimeseriesforecasts2)

## ---- echo=F, eval=T, results='hide'-------------------------------------
 souvenirtimeseriesforecasts2 <- forecast(souvenirtimeseriesforecasts, h=48)
pdf("img/serie38.pdf")
 plot(souvenirtimeseriesforecasts2)
dev.off()

## ---- eval=F-------------------------------------------------------------
## plotForecastErrors(souvenirtimeseriesforecasts2$residuals)

## ---- echo=F, eval=T, results='hide'-------------------------------------
pdf("img/serie39.pdf")
plotForecastErrors(souvenirtimeseriesforecasts2$residuals)
dev.off()

